<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>HoC-vs-RenderProps-vs-Hooks</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<h1 id="hoc-pattern-vs-render-props-pattern-vs-hooks-not-pattern-a-new-api">HoC (pattern) vs Render Props (pattern) vs Hooks (not pattern, a new API)</h1>
<p>Someone was asking me about comparing the HoC and Render Props patterns (and their shortcomings) to hooks. I might leave this up as a public gist for others if it’s helpful.</p>
<hr />
<p>tldr;</p>
<p>Issues with HoC:</p>
<ul>
<li>Prop Collisions (sometimes)</li>
<li>Can’t use the HoC twice</li>
<li>Indirection</li>
<li>Composing happens at build-time (can cause issues)</li>
</ul>
<p>Issues with Render Props</p>
<ul>
<li>Ugly (deep nesting)</li>
<li>Scoping Issues (sometimes)</li>
</ul>
<p>Hooks solve all the issues that both HoC’s and Render Props Have.</p>
<hr />
<p>Some main points we need to understand first:</p>
<ol type="1">
<li>In React, it’s really easy to create re-usable JSX. Just take your component and its JSX you want to share and make it a child component:</li>
</ol>
<pre class="jsx"><code>function MyComponent() {
  return (
    &lt;div className=&quot;browse-users&quot;&gt;
      &lt;div className=&quot;user-item&quot;&gt;Name: Brad&lt;/div&gt;
      &lt;div className=&quot;user-item&quot;&gt;Name: Ryan&lt;/div&gt;
      &lt;div className=&quot;user-item&quot;&gt;Name: Nathan&lt;/div&gt;
    &lt;/div&gt;
  )
}

// Can be refactored to
function MyComponent() {
  return (
    &lt;div className=&quot;browse-users&quot;&gt;
      &lt;UserItem name={Brad}&gt;
      &lt;UserItem name={Ryan}&gt;
      &lt;UserItem name={Nathan}&gt;
    &lt;/div&gt;
  )
}</code></pre>
<p>But it’s not so obvious how to make our state and lifecycle methods re-usable. Imagine a class-based component having state and lifecycle methods that orchestrate the state - because these are methods in a class, we can’t just “share” these methods with other classes - and btw in React, making our own base component to extend (thinking in terms of inheritance as if we’re doing OOP) is NOT a good idea in React.</p>
<p>So, two patterns were created by the community: Higher Order Components (HoC) and Render Props</p>
<ol start="2" type="1">
<li>HoC and Render Props are “design patterns” which means they aren’t things that are “built into” the React library, they’re more like “strategies” for writing code. Whereas Hooks is a new tool (API) that we have which is provided by React itself. One of the goals of hooks is to make state and the code that orchestrates it (not called lifecycles in hooks but similar idea) reusable.</li>
</ol>
<p>So you can think of hooks as being a “more official” way now to abstract re-usable state/functionality whereas all we had before were patterns because React didn’t have an official way</p>
<p>Understanding these two main points is required before we continue.</p>
<hr />
<h2 id="hoc">HoC</h2>
<p>HoC’s are a way of composing two components together - a parent and a child. When we have a file like this:</p>
<pre class="jsx"><code>// File: MyComponent.js
import React from &quot;react&quot;;

function MyComponent({ props, from, HoC }) {
  // ...
}

export default someHocFunction(MyComponent);
//             ^^^^^ this function is the HoC</code></pre>
<p>It seems like the thing we’re exporting is <code>MyComponent</code>. Afterall, the file is called <code>MyComponent.js</code> and when we import this thing, we do so like this: <code>import MyComponent from './MyComponent</code>. But if you look closely, we’re really exporting whatever the return value of the HoC function is. HoC’s take your component you pass in and they wrap it in a parent component. They give you that parent component back with your component as the child. It’s very important to realise that when we do <code>&lt;MyComponent /&gt;</code>, the “MyComponent” part is actually the parent wrapper from the HoC and not exacly the “MyComponent” that we wrote. That’s okay because the parent wrapper is going to in turn render our “MyComponent” as it’s child. Let’s continue.</p>
<p>The parent component provided by the HoC is what has the re-usable state and functionality. That parent component gives the child component access to the state and functionality via props.</p>
<p>By reusable, I mean we can do this:</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="co">// MyMenu.js</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="im">export</span> <span class="im">default</span> <span class="at">withToggle</span>(MyMenu)</a>
<a class="sourceLine" id="cb3-3" title="3"></a>
<a class="sourceLine" id="cb3-4" title="4"><span class="co">// ActivateUser.js</span></a>
<a class="sourceLine" id="cb3-5" title="5"><span class="im">export</span> <span class="im">default</span> <span class="at">withToggle</span>(ActivateUser)</a></code></pre></div>
<p>Imagine we had two files, one for a menu and one for activating users. Both need the ability to “toggle” something on and off. Each uses a <code>withToggle</code> HoC to handle the toggling state and functionality.</p>
<p>If we understand this much about HoC’s we can start to talk about their shortcomings.</p>
<h4 id="prop-collisions">1. Prop Collisions</h4>
<p>The first and most obvious shortcoming of HoC is “prop collisions”. If you carefully read what I said above, you’ll realize that when we do this:</p>
<pre class="jsx"><code>&lt;MyComponent name=&quot;Brad&quot; /&gt;</code></pre>
<p>We’re actually passing the prop <code>name</code> to the parent “wrapper component” that was provided by the HoC – we’re not passing name to what we think which is the <code>MyComponent</code> that we wrote. Technically, it’s the job of the HoC to forward those props on to it’s child which is the real <code>MyComponent</code> that we wrote, so it <em>feels</em> like doing <code>&lt;MyComponent name="Brad" /&gt;</code> is working directly with our <code>MyComponent</code>, but there is this middle-man component which is that parent from the HoC.</p>
<p>This means we could have “prop collisions” between what we want to pass into <code>MyComponent</code> and what the HoC wants to pass in. What if we pass <code>name</code> but the HoC also wants to pass in a prop called <code>name</code>. This might not happen often, but it can happen and will cause bugs in your code. This problem does not exist with Render Props or Hooks as we’ll see later on.</p>
<p>When it comes to prop collisions, one can easily say “well it doesn’t happen often and I can just rename my prop to not collide with the one the HoC is giving, problem solved”. But often times we need to compose several pieces of re-usable code into our component:</p>
<pre class="jsx"><code>export default someHoC(anotherHoc(coolHoc(MyComponent)));</code></pre>
<p>This might look a little strange, but it does work. You can wrap your <code>MyComponent</code> in more than one HoC at the same time. This just means your <code>MyComponent</code> will have lots of “parents” that are each providing different abstractions for state and functionality. Remember, the way our HoC gives us access to that functionality is via props. Can you honestly look at those three HoC’s and tell me for sure that none of them use the same prop names as the others? Obviously you cannot.</p>
<h4 id="cant-use-the-hoc-twice">2. Can’t use the HoC twice</h4>
<p>As we just saw, you can use more than one HoC on a component. It’s actually very useful for our component to be able to use several abstractions at one, but what if we want the same HoC twice?</p>
<pre class="jsx"><code>export default withToggle(withToggle(MyComponent));</code></pre>
<p>What if <code>MyComponent</code> needs to have two different things that toggle. Now we have a big problem because we will certainly 100% get prop collisions.</p>
<h4 id="indirection">3. Indirection</h4>
<p>Speaking of those props being passed in, let’s take a look at the props that <code>MyComponent</code> receives:</p>
<pre class="jsx"><code>function MyComponent({
  name,
  onClick,
  setValue,
  time,
  date,
  isActive,
  isRemoved,
}) {
  // ...
}

export default someHoC(anotherHoc(coolHoc(MyComponent)));</code></pre>
<p>Can you tell me which of those props are coming from which HoC? Which props are not coming from the HoC’s and you’re supposed to add yourself like <code>&lt;MyComponent name="Brad" /&gt;</code>?</p>
<h4 id="composing-at-build-time">4. Composing at build-time</h4>
<p>HoC’s compose at build time. What I mean is:</p>
<pre class="jsx"><code>export default someHoC(&quot;Some Value&quot;, MyComponent);</code></pre>
<p>Sometimes it might be nice to pass in other values to your HoC along with your component. But since this value is passed in at build time before <code>MyComponent</code> is turned into an element, we cannot use the props passed into <code>MyComponent</code> as arguments to the HoC. Let me explain.</p>
<p>Let’s say you write a bunch of React and you’re seeing that in many cases components just need to make one network request and then save the response into state so it can be used in the JSX. You decide to get clever and make this:</p>
<pre class="jsx"><code>export default fetchData(&quot;/users&quot;, BrowseUsers);</code></pre>
<p>Your <code>fetchData</code> HoC will take the first argument and will do a network request to get the information at <code>/users</code> and then it will take the results and send them into <code>BrowseUsers</code>. Sounds cool right? Now you don’t have to go around programming that same pattern of “componentDidMount, fetch data, setState, use state in JSX”</p>
<p>It all seems cool at first, but then later you realize that you have a component like this:</p>
<pre class="jsx"><code>&lt;UserProfile uid={5} /&gt;</code></pre>
<p>You want to do this:</p>
<pre class="jsx"><code>function UserProfile({ uid }) {
  // ...
}

export default fetchData(&quot;/users/???&quot;, UserProfile);</code></pre>
<p>But do you see the problem? The moment that you have access to the prop <code>uid</code> which is <code>5</code> now but could be anything later is something that is too dynamic to plug into our path for fetching users. How do I get the value <code>5</code> into the path where I have <code>???</code></p>
<h2 id="render-props">Render Props</h2>
<p>Render Props is considered to be an alternative pattern to HoC. The premise of a Render Prop is similar though in that it also creates a parent wrapper that has the reusable state/functions - but it doesn’t do this as a wrapper to our component:</p>
<pre class="jsx"><code>function MyComponent() {
  return (
    &lt;div&gt;
      &lt;h1&gt;My Page&lt;/h1&gt;
      &lt;Toggle
        render={(on, toggle) =&gt; {
          return (
            &lt;button onClick={toggle}&gt;The toggle is {on ? &quot;on&quot; : &quot;off&quot;}&lt;/button&gt;
          );
        }}
      /&gt;
      &lt;footer&gt;footer&lt;/footer&gt;
    &lt;/div&gt;
  );
}

export default MyComponent;</code></pre>
<p>When we did the re-usable toggle state as an HoC, there were props given to our entire <code>MyComponent</code>, but chances are we just needed the values of those props in the JSX. So instead let’s use a Render Prop pattern as shown above. <code>Toggle</code> is now a component unto itself which internally has all the state and functionality for managing a toggle value. It might look a little strange at first, but we’re actually passing a function into the prop of <code>render={fn}</code>. Then we are returning some JSX. Internally, the <code>Toggle</code> component calls render like this:</p>
<pre class="jsx"><code>class Toggle extends React.Component {
  // ...

  render() {
    return this.props.render(this.state.on, this.state.toggle);
  }
}</code></pre>
<p>Notice that <code>Toggle</code> doesn’t actually have an JSX, instead it uses the return value of <code>this.props.render</code>. The pattern allows <code>Toggle</code> to be in charge of the state and functionality but we give control of the JSX on the outside in <code>MyComponent</code>. You might think at first, “can’t we just do this?”:</p>
<pre class="jsx"><code>&lt;Toggle&gt;
  &lt;button&gt;&lt;/button&gt;
&lt;Toggle&gt;</code></pre>
<p>This is obviously one way to pass <code>button</code> as a child to <code>Toggle</code>, but in this case when <code>Toggle</code> receives it, the button will be <code>this.props.children</code> which isn’t something we can easily “send stuff to”. We could do this though:</p>
<pre class="jsx"><code>&lt;Toggle&gt;
  {(on, toggle) =&gt; {
    return &lt;button onClick={toggle}&gt;The toggle is {on ? &#39;on&#39; : &#39;off&#39;}&lt;/button&gt;
  }}
&lt;Toggle&gt;</code></pre>
<p>Technically, we could pass a function as the <code>children</code>. This might look different than doing the actual prop called <code>render</code>, but actually it’s the exact same thing. Using <code>children</code> instead of <code>render</code> is also called Render Props.</p>
<h3 id="how-do-render-props-compare-to-hoc">How do Render Props compare to HoC?</h3>
<p>Pretty much all those problems we identified with HoC go away when we use Render Props. Prop collisions will not happen because when we pass our props to <code>MyComponent</code>:</p>
<pre class="jsx"><code>function MyComponent() {
  // ... code that has render props
}

export default MyComponent;</code></pre>
<p>Those props will not be mixed in with the props of the abstraction (the render props in this case). We can do <code>&lt;MyComponent name="brad" /&gt;</code> and that value will be accessible via <code>this.props.name</code> or <code>props.name</code> for functional components. If our Render Prop also needed to use the variable name <code>name</code>, it would look like this:</p>
<pre class="jsx"><code>function MyComponent({ name }) {
  console.log(name);
  return (
    &lt;div&gt;
      &lt;SomeRenderPropsThing&gt;
        {({ name: otherName }) =&gt; {
          // ...
        }}
      &lt;/SomeRenderPropsThing&gt;
    &lt;/div&gt;
  );
}

export default MyComponent;</code></pre>
<p>Notice we can alias the name - not something we could have done with HoC’s</p>
<p>How about using the same Render Prop twice? Easy:</p>
<pre class="jsx"><code>function MyComponent({ name }) {
  console.log(name);
  return (
    &lt;div&gt;
      &lt;h1&gt;My Page&lt;/h1&gt;
      &lt;Toggle
        render={(on, toggle) =&gt; {
          return (
            &lt;button onClick={toggle}&gt;The toggle is {on ? &quot;on&quot; : &quot;off&quot;}&lt;/button&gt;
          );
        }}
      /&gt;
      &lt;footer&gt;footer&lt;/footer&gt;
      &lt;Toggle
        render={(on, toggle) =&gt; {
          return (
            &lt;button onClick={toggle}&gt;The toggle is {on ? &quot;on&quot; : &quot;off&quot;}&lt;/button&gt;
          );
        }}
      /&gt;
    &lt;/div&gt;
  );
}

export default MyComponent;</code></pre>
<p>And the values provided to us by <code>Toggle</code> don’t collide because their in two different functions. Also notice that the indirection doesn’t exist. We’re not getting a big bag of props and wondering where they came from. All of our props in <code>MyComponent</code> come from us. Then the variables given to us from Render Props are not props on <code>MyComponent</code>, but easily identifiable values from their respective Render Prop abstraction.</p>
<p>How about that “data fetching” abstraction?</p>
<blockquote>
<p>I’m not trying to say you should make this fetching thing as an HoC or a RenderProp, keep in mind I’m just trying to illustrates an example of an abstraction that <em>needs</em> to be given some dynamic data as it’s input. Data fetching is just an easy example</p>
</blockquote>
<p>Before we needed to take a prop like <code>uid</code> and and give it to the code that does the abstraction:</p>
<pre class="jsx"><code>&lt;UserProfile uid={5} /&gt;;

// the UserProfile code:
function UserProfile() {}

export default fetchData(&quot;/how/do/I/get/the/prop/5/here??&quot;, UserProfile);</code></pre>
<p>Now with Render Props, it’s easy:</p>
<pre class="jsx"><code>&lt;UserProfile uid={5} /&gt;;

// the UserProfile code:
function UserProfile({ uid }) {
  return (
    &lt;div&gt;
      &lt;FetchData
        url={`/users/${uid}`}
        render={(results) =&gt; {
          return &lt;div&gt;User: results.name&lt;/div&gt;;
        }}
      /&gt;
    &lt;/div&gt;
  );
}

export default UserProfile;</code></pre>
<p>Render Props solve all the problems I know about that HoC’s introduce. However, they do have some new problems that HoC’s never had, although one of the new problems is a little silly perhaps.</p>
<ol type="1">
<li>Render Props look ugly! HoC’s are nice looking because we just call a function where we do the export and now we just get these magic props that show up. But Render Props require deeper nesting of our JSX and make it look terrible.</li>
<li>The values given to us by the Render Props are scoped to the function we pass into <code>render</code> or <code>children</code>. This is one of the reasons why Render Props solves problems of HoC’s but what if we need those values in the lifecycle methods for any reason? Not easy with Render Props. With HoC’s those values provided were props at the top level of our component so that wasn’t a problem.</li>
</ol>
<h2 id="enter-hooks">Enter, Hooks!!</h2>
<p>Remember, Hooks are not a third-pattern that simply serves as an alternative to the two we’ve discussed. Hooks are a whole new way to think about writing React and it just so happens that we don’t need the HoC and Render Props patterns as much anymore (if at all) since hooks solves those problems in a much nicer way.</p>
<p>This is not an explanation of how hooks works. I’ll assume you know enough about hooks to understand my contrast of them to HoC and Render Props.</p>
<p>The main “problems” around HoC’s and Render Props revolved around “how” the values of the abstraction were given to our component. Either they were coming in from outside the component as props and therefore we would get prop collisions and indirection, or we would get those values scoped to a function which means we don’t have access to those values everywhere in our component. When we write custom hooks, they look like this:</p>
<pre class="jsx"><code>function MyComponent({ uid }) {
  const results = useFetch(`/users/${uid}`);
  const { on: menuOn, toggle: toggleMenuOn } = useToggle();
  const { on: userOn, toggle: toggleUserOn } = useToggle();

  return &lt;div&gt;// ...&lt;/div&gt;;
}

export default MyComponent;</code></pre>
<p>Problems with HoC solved with Hooks</p>
<ul>
<li>No variable collisions</li>
<li>No indirection</li>
<li>We can use the same custom hook twice</li>
<li>Composing happens at runtime so we can take our props and use them in hooks (<code>uid</code> in this case)</li>
</ul>
<p>Problems with Render Props solved with Hooks</p>
<ul>
<li>Not ugly, doesn’t cause deep nesting</li>
<li>Values given to us by the custom hooks are scoped to the top level of the component itself and not just a limited place in the JSX</li>
</ul>
<hr />
<p>I’d prefer questions on Twitter if you have any <span class="citation" data-cites="bradwestfall">@bradwestfall</span></p>
</body>
</html>
